<?php
namespace Teknisa\DF\Modules\Entrada\Factories;

use Doctrine\ORM\EntityManager;

class Dfe52000RelacionamentoProdutoXProduto {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function checaProdutoXMLExistente($cdprodutoxml, $cdforneced, $cdproduto, $cdfilial, $dataSourceName) {
        if ($dataSourceName == 'produto_comprodutosxmls' || $dataSourceName == 'replic_produto_comprodutosxmls') {
            $sql = "SELECT PX.CDPRODUTOXML, P.CDARVPROD, P.NMPRODUTO
                    FROM PRODFORNXML PX
                    INNER JOIN PRODUTO P
                      ON PX.CDPRODUTO    = P.CDPRODUTO
                      AND PX.NRORG = P.NRORG
                    WHERE CDPRODUTOXML = :P_CDPRODUTOXML
                      AND CDFORNECED     = :P_CDFORNECED
                      AND PX.CDPRODUTO = :P_CDPRODUTO";
                      
            $params = array("P_CDPRODUTOXML"=>$cdprodutoxml,
                            "P_CDFORNECED"=>$cdforneced,
                            "P_CDPRODUTO"=>$cdproduto);
        }
        else {
            $sql = "SELECT PX.CDPRODUTOXML, P.CDARVPROD, P.NMPRODUTO
                    FROM PRODFORNXMLFIL PX
                    INNER JOIN PRODUTO P
                      ON PX.CDPRODUTO    = P.CDPRODUTO
                      AND PX.NRORG = P.NRORG
                    WHERE CDPRODUTOXML = :P_CDPRODUTOXML
                      AND CDFORNECED     = :P_CDFORNECED
                      AND PX.CDPRODUTO = :P_CDPRODUTO
                      AND PX.CDFILIAL = :P_CDFILIAL";
                      
            $params = array("P_CDPRODUTOXML"=>$cdprodutoxml,
                            "P_CDFORNECED"=>$cdforneced,
                            "P_CDPRODUTO"=>$cdproduto,
                            "P_CDFILIAL" =>$cdfilial);
        }

        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }
    
    public function editRow($oldCdprodutoxml, $oldCdproduto, $cdforneced, $cdproduto, $nrorg, $newCdprodutoxml, $nmprodutoxml, $fatconvol, $cdfilial, $dataSourceName) {
        if ($dataSourceName == 'produto_comprodutosxmls') {
            $sql = "UPDATE PRODFORNXML
                    SET CDPRODUTOXML = :P_CDPRODUTOXML,
                        NMPRODUTOXML = :P_NMPRODUTOXML,
                        VRFATCONVOL  = :P_VRFATCONVOL,
                        CDPRODUTO    = :P_CDPRODUTO
                    WHERE CDPRODUTO    = :P_OLDCDPRODUTO
                      AND CDFORNECED   = :P_CDFORNECED
                      AND CDPRODUTOXML = :P_OLDCDPRODUTOXML
                      AND NRORG        = :P_NRORG";
                      
            $params = array("P_OLDCDPRODUTOXML"=>$oldCdprodutoxml,
                            "P_OLDCDPRODUTO"=>$oldCdproduto,
                            "P_CDFORNECED"=>$cdforneced,
                            "P_CDPRODUTO"=>$cdproduto,
                            "P_NRORG"=>$nrorg,
                            "P_CDPRODUTOXML"=>$newCdprodutoxml,
                            "P_NMPRODUTOXML"=>$nmprodutoxml,
                            "P_VRFATCONVOL"=>$fatconvol);
        }
        else {
            $sql = "UPDATE PRODFORNXMLFIL
                    SET CDPRODUTOXML = :P_CDPRODUTOXML,
                        NMPRODUTOXML = :P_NMPRODUTOXML,
                        VRFATCONVOL  = :P_VRFATCONVOL,
                        CDPRODUTO    = :P_CDPRODUTO
                    WHERE CDPRODUTO    = :P_OLDCDPRODUTO
                      AND CDFORNECED   = :P_CDFORNECED
                      AND CDPRODUTOXML = :P_OLDCDPRODUTOXML
                      AND NRORG        = :P_NRORG
                      AND CDFILIAL     = :P_CDFILIAL";
                      
            $params = array("P_OLDCDPRODUTOXML"=>$oldCdprodutoxml,
                            "P_OLDCDPRODUTO"=>$oldCdproduto,
                            "P_CDFORNECED"=>$cdforneced,
                            "P_CDPRODUTO"=>$cdproduto,
                            "P_NRORG"=>$nrorg,
                            "P_CDPRODUTOXML"=>$newCdprodutoxml,
                            "P_NMPRODUTOXML"=>$nmprodutoxml,
                            "P_VRFATCONVOL"=>$fatconvol,
                            "P_CDFILIAL"=>$cdfilial);
        }

        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
    
    public function getFranqueadora() {
  
        $query = "SELECT CDFILIAL FROM FILIAL WHERE IDFUNCAOFILI = 'F'";
        
        $std = $this->connection->prepare($query);
        try {
            $std->execute();
            $existe = $std->fetch();
            if(isset($existe["CDFILIAL"])) {
             return $existe["CDFILIAL"];   
            }
            else return false;
        }
        catch(\Exception $e) {
            return false;    
        }
    }
    
    public function getAllFornecedor($nmrazsocforn) {
        $sql = "SELECT
                    F.CDFORNECED
                FROM
                    FORNECEDOR       F,
                    PARAMFORNE       PF
                WHERE
                    F.CDFORNECED = PF.CDFORNECED
                    AND F.NRORG = PF.NRORG
                    AND PF.CDFORNECED = F.CDFORNECED
                    AND PF.IDBLOQALTPRODREL = 'N'
                    AND F.IDSITUCADA = 'A'
                    AND F.CDFORNECED <> (SELECT CDFORNECED FROM FORNECEDOR WHERE NMRAZSOCFORN = :P_NMRAZSOCFORN)";
        
        $params = array( "P_NMRAZSOCFORN" => $nmrazsocforn);
        
        
        $query = $this->connection->prepare($sql);
        $query->execute($params);
        return $query->fetchAll();
    }
    
    public function deleteReplicacao($cdforneceddestino) {
        $sql = "DELETE FROM PRODFORNXML
                WHERE CDFORNECED = :P_CDFORNECEDDESTINO";
            
        $params = array(
            "P_CDFORNECEDDESTINO" => $cdforneceddestino
        );
                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function realizaReplicacao($cdforneceddestino, $cdfornecedorigem){
        $sql = "INSERT INTO PRODFORNXML(CDPRODUTO, CDFORNECED, CDPRODUTOXML, NMPRODUTOXML, VRFATCONVOL, CDMARCAREL)
                SELECT CDPRODUTO, :P_CDFORNECEDDESTINO, CDPRODUTOXML, NMPRODUTOXML, VRFATCONVOL, CDMARCAREL
                FROM PRODFORNXML
                WHERE CDFORNECED = :P_CDFORNECEDORIGEM";
        
        $params = array(
            "P_CDFORNECEDDESTINO" => $cdforneceddestino,
            "P_CDFORNECEDORIGEM" => $cdfornecedorigem
        );
                        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function deleteReplicacaoFilial($cdforneceddestino, $cdfilial) {
        $sql = "DELETE FROM PRODFORNXMLFIL
                WHERE CDFORNECED = :P_CDFORNECEDDESTINO AND CDFILIAL = :P_CDFILIAL";
            
        $params = array(
            "P_CDFORNECEDDESTINO" => $cdforneceddestino,
            "P_CDFILIAL" => $cdfilial
        );
                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function realizaReplicacaoFilial($cdforneceddestino, $cdfornecedorigem, $cdfilial){
        $sql = "INSERT INTO PRODFORNXMLFIL(CDPRODUTO, CDFORNECED, CDPRODUTOXML, NMPRODUTOXML, VRFATCONVOL, CDFILIAL)
                SELECT CDPRODUTO, :P_CDFORNECEDDESTINO, CDPRODUTOXML, NMPRODUTOXML, VRFATCONVOL, CDFILIAL
                FROM PRODFORNXMLFIL
                WHERE CDFORNECED = :P_CDFORNECEDORIGEM AND CDFILIAL = :P_CDFILIAL";
        
        $params = array(
            "P_CDFORNECEDDESTINO" => $cdforneceddestino,
            "P_CDFORNECEDORIGEM" => $cdfornecedorigem,
            "P_CDFILIAL" => $cdfilial
        );
                        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
}